// MQL4&5-code
// #define REPORT_TESTER       //      
// #define REPORT_BROWSER      //      -   DLL.
// #define REPORT_MT4_GRAPHICS //     MT4. Graphics-  MT5   .
// #define REPORT_RANNFOREX    //     MT4-.

#ifdef __MQL5__
  #define REPORT_GRAPHICS
  #define REPORT_SLIPPAGE

  #ifndef __VIRTUAL__
    #include <MT4Orders.mqh> // https://www.mql5.com/ru/code/16006
  #endif // __VIRTUAL__

  #ifndef MAGIC_TYPE
    #define MAGIC_TYPE long
  #endif // MAGIC_TYPE
#else // __MQL5__
  #ifdef REPORT_MT4_GRAPHICS
    #define REPORT_GRAPHICS
  #endif // REPORT_MT4_GRAPHICS

  #ifdef REPORT_RANNFOREX
    #define REPORT_SLIPPAGE
  #endif // REPORT_RANNFOREX

  #ifndef MAGIC_TYPE
    #define MAGIC_TYPE int
  #endif // MAGIC_TYPE

  #ifndef OP_BALANCE
    #define OP_BALANCE 6
  #endif // OP_BALANCE
#endif // __MQL5__

#property strict

#ifdef REPORT_GRAPHICS
  #include <Graphics\Graphic.mqh>
#endif // REPORT_GRAPHICS

#ifdef REPORT_BROWSER
  #import "shell32.dll"
    int ShellExecuteW( int, string, string, string, string, int );
  #import

  #ifdef __MQL5__
    #define BASEPATH (::TerminalInfoString(TERMINAL_DATA_PATH) + "\\MQL5\\Files\\")
    #define BASEPATH_TESTER BASEPATH
  #else // __MQL5__
    #define BASEPATH (::TerminalInfoString(TERMINAL_PATH) + "\\MQL4\\Files\\")
    #define BASEPATH_TESTER (::TerminalInfoString(TERMINAL_PATH) + "\\tester\\Files\\")
  #endif // __MQL5__
#endif // REPORT_BROWSER

enum ENUM_REPORT_CHART
{
   REPORT_BALANCE,
   REPORT_PIPS,
   REPORT_GAIN,
   REPORT_TURNOVER
};

#define WIDTH 1025
#define HEIGHT 400

#define ALL_MAGICS (-1)
#define ALL_SYMBOLS NULL

struct REPORT_FILTER
{
  string Symb;
  long Magic;
  bool Pending;
  bool Balance;
  datetime StartTime;
  datetime EndTime;
  bool Anonym;

  REPORT_FILTER( void ) : Symb(ALL_SYMBOLS), Magic(ALL_MAGICS), Pending(true), Balance(true), StartTime(0), EndTime(INT_MAX), Anonym(false)
//  REPORT_FILTER( void ) : Symb(ALL_SYMBOLS), Magic(ALL_MAGICS), Pending(false), Balance(true), StartTime(0), EndTime(INT_MAX), Anonym(false)
  {
  }

  bool Is( void ) const
  {
    return(((this.Balance && (OrderType() == OP_BALANCE)) || (this.Pending && (OrderType() > OP_SELL)) || (OrderType() <= OP_SELL)) &&
            ((this.Magic == ALL_MAGICS) || (OrderMagicNumber() == this.Magic)) &&
            (OrderCloseTime() >= this.StartTime) && (OrderCloseTime() < this.EndTime) &&
            ((this.Symb == ALL_SYMBOLS) || (OrderSymbol() == Symb)));
  }
};

#undef ALL_SYMBOLS
#undef ALL_MAGICS

class REPORT
{
private:
  static int AmountFields;
  static const string Shablon;

  static double Balance[];
  static double BalanceNoCommission[];

  static double Pips[];

  static double Gain[];
  static double GainNoCommission[];

  static double TurnOver[];

  static string Report;

#ifdef REPORT_SLIPPAGE
  static double BalanceNoSlip[];
  static double BalanceNoSlipCommission[];

  static double PipsNoSlip[];

  static double GainNoSlip[];
  static double GainNoSlipCommission[];

#endif // REPORT_SLIPPAGE

#ifdef REPORT_TESTER
  static const ulong TimeStart;

#ifdef __MQL5__
  static int OnTesterPasses;
  static string TimeBegin;
  static datetime TimeEnd;

  static string TimeStr;
  static const string TimeName;
#endif // __MQL5__
#endif // REPORT_TESTER

  static string StringBetween( string &Str, const string StrBegin, const string StrEnd = NULL )
  {
    int PosBegin = ::StringFind(Str, StrBegin);
    PosBegin = (PosBegin >= 0) ? PosBegin + ::StringLen(StrBegin) : 0;

    const int PosEnd = ::StringFind(Str, StrEnd, PosBegin);

    const string Res = ::StringSubstr(Str, PosBegin, (PosEnd >= 0) ? PosEnd - PosBegin : -1);
    Str = (PosEnd >= 0) ? ::StringSubstr(Str, PosEnd + ::StringLen(StrEnd)) : NULL;

    if (Str == "")
      Str = NULL;

    return(Res);
  }

  static void GetSlips( string Str, int &OpenSlip, int &CloseSlip )
  {
    OpenSlip = (int)(double)REPORT::StringBetween(Str, "[", ";");
    CloseSlip = (int)(double)Str;

    return;
  }

  static double OrderOpenPriceRequest2( void ) // Virtual.mqh
  {
  #ifdef __MQL5__
    return(OrderOpenPriceRequest());
  #else // __MQL5__
    #ifdef // REPORT_RANNFOREX
      #ifdef __VIRTUAL__
        if (VIRTUAL::GetHandle())
          return(OrderOpenPriceRequest());
        else
      #endif // __VIRTUAL__
      {
        int OpenSlip;
        int CloseSlip;

        double Res = OrderOpenPrice();

        if (OrderType() <= OP_SELL)
        {
          REPORT::GetSlips(OrderComment(), OpenSlip, CloseSlip);

          if (OpenSlip)
          {
            const int digits = (int)::SymbolInfoInteger(OrderSymbol(), SYMBOL_DIGITS);
            const double point = ::SymbolInfoDouble(OrderSymbol(), SYMBOL_POINT);

            Res = ::NormalizeDouble(Res + (OrderType() ? -OpenSlip : OpenSlip) * point, digits);
          }
        }

        return(Res);
      }
    #else // REPORT_RANNFOREX
      #ifdef __VIRTUAL__
        return(OrderOpenPriceRequest());
      #else // __VIRTUAL__
        return(OrderOpenPrice());
      #endif // __VIRTUAL__
    #endif // REPORT_RANNFOREX
  #endif // __MQL5__
  }

  static double OrderClosePriceRequest2(void ) // Virtual.mqh
  {
  #ifdef __MQL5__
    return(OrderClosePriceRequest());
  #else // __MQL5__
    #ifdef // REPORT_RANNFOREX
      #ifdef __VIRTUAL__
        if (VIRTUAL::GetHandle())
          return(OrderClosePriceRequest());
        else
      #endif // __VIRTUAL__
      {
        int OpenSlip;
        int CloseSlip;

        double Res = OrderClosePrice();

        if (OrderType() <= OP_SELL)
        {
          GetSlips(OrderComment(), OpenSlip, CloseSlip);

          if (CloseSlip)
          {
            const int digits = (int)::SymbolInfoInteger(OrderSymbol(), SYMBOL_DIGITS);
            const double point = ::SymbolInfoDouble(OrderSymbol(), SYMBOL_POINT);

            Res = ::NormalizeDouble(Res + (OrderType() ? CloseSlip : -CloseSlip) * point, digits);
          }
        }

        return(Res);
      }
    #else // REPORT_RANNFOREX
      #ifdef __VIRTUAL__
        return(OrderClosePriceRequest());
      #else // __VIRTUAL__
        return(OrderClosePrice());
      #endif // __VIRTUAL__
    #endif // REPORT_RANNFOREX
  #endif // __MQL5__
  }

  static string GetTickFlag( uint tickflag )
  {
    string flag = " " + (string)tickflag;

  #define TICKFLAG_MACRO(A) flag += ((bool)(tickflag & TICK_FLAG_##A)) ? " TICK_FLAG_" + #A : ""; \
                            tickflag -= tickflag & TICK_FLAG_##A;
    TICKFLAG_MACRO(BID)
    TICKFLAG_MACRO(ASK)
    TICKFLAG_MACRO(LAST)
    TICKFLAG_MACRO(VOLUME)
    TICKFLAG_MACRO(BUY)
    TICKFLAG_MACRO(SELL)
  #undef TICKFLAG_MACRO

    if (tickflag)
      flag += " FLAG_UNKNOWN (" + (string)tickflag + ")";

    return(flag);
  }

  #define TOSTR(A) " " + #A + " = " + (string)Tick.A
  #define TOSTR2(A) " " + #A + " = " + ::DoubleToString(Tick.A, _Digits)

  static string TickToString( const MqlTick &Tick )
  {
    return(TOSTR(time) + "." + ::IntegerToString(Tick.time_msc % 1000, 3, '0') +
           TOSTR2(bid) + TOSTR2(ask) + TOSTR2(last)+ TOSTR(volume) + REPORT::GetTickFlag(Tick.flags));
  }

  #undef TOSTR2
  #undef TOSTR

  static string DoubleToString( const double Num, const int digits )
  {
    return(Num ? ::DoubleToString(Num, digits) : "");
  }

  template <typename T>
  static string NumToString( T Num, const bool CheckType = true, const int digits = 2 )
  {
    if (CheckType && (OrderType() == OP_SELL))
      Num = -Num;

    return(((Num > 0) ? "+" : "") + ((typename(T) == "double") ? ::DoubleToString(Num, digits) : (string)Num));
  }

  static string VolumeToString( double dVolume, const string Delimeter = " " )
  {
    dVolume = dVolume + 0.001;

    long Round = (long)dVolume;
    string Res = "." + ::IntegerToString((long)(dVolume * 100) % 100, 2, '0');

    Res = ((bool)(Round / 1000) ? ::IntegerToString(Round % 1000, 3, '0') : (string)(Round % 1000)) + Res;

    Round /= 1000;

    while (Round)
    {
      Res = ((bool)(Round / 1000) ? ::IntegerToString(Round % 1000, 3, '0') : (string)(Round % 1000)) + Delimeter + Res;

      Round /= 1000;
    }

    return(Res);
  }

  static string LengthToString( const datetime Length )
  {
    const int Days = (int)(Length / (24 * 3600));

    return(((Days) ? (string)Days + "d ": "") + ::TimeToString(Length, TIME_SECONDS));
  }

  static string LengthToString( const long Length )
  {
    return(REPORT::LengthToString((datetime)(Length / 1000)) + "." + ::IntegerToString(Length % 1000, 3, '0'));
  }

  static int PriceToPips( const double Price, const double point )
  {
    return(point ? ((int)(Price / point + 0.1)) : 0);
  }

  static int ProfitToPips( const double PriceClose, const double PriceOpen, const double point )
  {
    return(REPORT::PriceToPips(PriceClose, point) - REPORT::PriceToPips(PriceOpen , point));
  }

  static int GetSymbolPos( const string Symb )
  {
    static string Symbols[];

    const int Size = ::ArraySize(Symbols);

    int Pos = 0;

    while ((Pos < Size) && (Symbols[Pos] != Symb))
      Pos++;

    if (Pos == Size)
    {
      ::ArrayResize(Symbols, Size + 1);

      Symbols[Pos] = Symb;
    }

    return(Pos);
  }

  //         
  static double GetTickValue()
  {
    static double TickValue[];

    const int Pos = REPORT::GetSymbolPos(OrderSymbol());
    const int Size = ::ArraySize(TickValue);

    if (Pos >= Size)
      ::ArrayResize(TickValue, Pos + 1);

//    const double TmpPips = NormalizeDouble(OrderClosePrice() - OrderOpenPrice(), 8); // https://www.mql5.com/ru/forum/170952/page128#comment_10696343
    const double TmpPips = OrderClosePrice() - OrderOpenPrice();
    const double Lots = OrderLots();

    if (TmpPips && Lots/* && OrderProfit()*/) //     - OrderType() > OP_SELL
      TickValue[Pos] = ::MathAbs(OrderProfit() / (TmpPips * Lots));

    return(TickValue[Pos]);
  }

  static string AddField( void )
  {
    REPORT::AmountFields++;

    return(NULL);
  }

#define ANONYM(A) (Filter.Anonym ? "" : (string)(A))

  static void Head( string &Res, const REPORT_FILTER &Filter )
  {
    const string AccountNumber = ANONYM(::AccountInfoInteger(ACCOUNT_LOGIN));
    const string AccountName = ANONYM(::AccountInfoString(ACCOUNT_NAME));

    Res = "<html><head>\n" +
          "<meta http-equiv=\"Pragma\" content=\"no-cache\">" +
          "<title>Statement: \'" + AccountNumber + " \', " + AccountName + "</title>\n" +
          "<style type=\"text/css\" media=\"screen\">\n" +
          "td {font: 8pt Tahoma,Arial;}\n" +
          ".td1 {padding-left:3px; padding-right:3px;}\n" +
          "</style>\n" +
          "<style type=\"text/css\" media=\"print\">\n" +
          "td {font: 7pt Tahoma,Arial; }\n" +
          "</style>\n" +
          "</head>\n" +
          "<body topmargin=1 marginheight=1>\n" +
          "<div align=center>\n" +
        #ifdef REPORT_TESTER
          "<div>Clear Pass time: " + ::DoubleToString((::GetMicrosecondCount() - REPORT::TimeStart) / 1e6, 3)+ " s.</div>\n" +
        #endif // REPORT_TESTER
          "<div>Report Generation time: ::GENERATE:: s.</div>\n" +
          "<div>Report Size: ::SIZE:: Kb." + "</div>\n" +
          "<div>Time: ::TIME::" + "</div>\n" +
        #ifdef ERR_USER_INVALID_HANDLE // Graphics\Graphic.mqh from StdLibErr.mqh - https://www.mql5.com/ru/forum/211620#comment_5482547
          ((!::MQLInfoInteger(MQL_TESTER)
        #ifdef __MQL5__
        #ifdef __TYPETOBYTES__
          || ::MQLInfoInteger(MQL_OPTIMIZATION)
        #endif // __TYPETOBYTES__
          || ::MQLInfoInteger(MQL_VISUAL_MODE) || ::MQLInfoInteger(MQL_FRAME_MODE)
        #else // __MQL5__
          || ::MQLInfoInteger(MQL_VISUAL_MODE)
        #endif // __MQL5__
          ) ? "<img src=\"::BALANCE::\">\n<img src=\"::PIPS::\">\n<img src=\"::GAIN::\">\n<img src=\"::TURNOVER::\">\n": "") +
          "<div>HistoryInterval: " +
          ::TimeToString(::MathMax(Filter.StartTime, OrderSelect(0, SELECT_BY_POS, MODE_HISTORY) ?
          (OrderOpenTime() ? OrderOpenTime()
                           : (OrderSelect(1, SELECT_BY_POS, MODE_HISTORY) ? OrderOpenTime() : 0)) : Filter.StartTime), TIME_DATE) + " - " +
          ::TimeToString(::MathMin(Filter.EndTime, 24 * 3600 + ::MathMax(::TimeCurrent(),
                         (OrderSelect(OrdersHistoryTotal() - 1, SELECT_BY_POS, MODE_HISTORY) ? OrderCloseTime() : 0))), TIME_DATE) + "</div>\n" +
        #endif // ERR_USER_INVALID_HANDLE
          (::MQLInfoInteger(MQL_TESTER) ? "<div>ExpertName: " + ANONYM(::MQLInfoString(MQL_PROGRAM_NAME)) +" (" + ::Symbol() +
        #ifdef __MQL5__
          (::SymbolInfoInteger(::Symbol(), SYMBOL_CUSTOM) ? " - Custom (" + ::SymbolInfoString(::Symbol(), SYMBOL_CURRENCY_PROFIT) + ")" : "") +
        #endif // __MQL5__
                                          ")</div>\n" : "") +
        #ifdef __MQL5__
          (::MQLInfoInteger(MQL_OPTIMIZATION) ? "Input Parameters:" + "<div>Tester Pass:</div>\n" : "") +
        #endif // __MQL5__
          "<div>Build: " + (string)::TerminalInfoInteger(TERMINAL_BUILD) + "</div>\n" +
          "<div>Server: " + ANONYM(::AccountInfoString(ACCOUNT_SERVER)) + "</div>\n" +
          "<div style=\"font: 20pt Times New Roman\"><b>" +
          ANONYM(::AccountInfoString(ACCOUNT_COMPANY))+ " (by RickD) " +
          /**/
          "</b></div>\n" +
          "<font face=\"tahoma,arial\" size=1>\n" +
          "<table cellspacing=1 cellpadding=2 border=0>\n" +

          "<tr>" +
          "<td colspan=2>A/C No: <b>" + AccountNumber + " (" + ::AccountInfoString(ACCOUNT_CURRENCY) + ", " +
        #ifdef __MQL5__
            (((ENUM_ACCOUNT_MARGIN_MODE)::AccountInfoInteger(ACCOUNT_MARGIN_MODE) == ACCOUNT_MARGIN_MODE_RETAIL_HEDGING) ? "Hedge" : "Netting") +
        #else  // __MQL5__
          "Hedge" +
        #endif // __MQL5__
          ")</b></td>" +
          "<td colspan=6>Name: <b>" + AccountName + "</b></td>" +
          "<td colspan=5 align=right>" + (string)::TimeLocal() + " (local time)</td>" +
          "</tr>\n" +
          "<tr><td colspan=13 style=\"font: 1pt arial\">&nbsp;</td></tr>\n" +
          "<tr><td colspan=13><b>Closed Transactions:</b></td></tr>\n" +

          "<tr align=center bgcolor=#c0c0c0>" +
          REPORT::Shablon + "</tr>\n";
  }

#define ADD(A, B) ::StringReplace(Str, #A, (string)(B))

  static string TypeToString( const int Type )
  {
    static const string Types[] = {"buy", "sell", "buy limit", "sell limit", "buy stop", "sell stop", "balance"};

    return(((Type < ::ArraySize(Types)) ? Types[Type] : "unknown"));
  }

  static string OrderToString( const int Num, const REPORT_FILTER &Filter )
  {
    //  -      ,       (  ),
    //            Digits  Point   ?

    const int digits = (int)::SymbolInfoInteger(OrderSymbol(), SYMBOL_DIGITS);
    const double point = ::SymbolInfoDouble(OrderSymbol(), SYMBOL_POINT);

    const double TickValue = (OrderType() <= OP_SELL) ? REPORT::GetTickValue() : 0;

    string Str = REPORT::Shablon;

    ADD(MagicNumber, ANONYM((!OrderMagicNumber()) ? "" : (string)OrderMagicNumber()));
    ADD(N, Num);
    ADD(Ticket, ANONYM(OrderTicket()));
    ADD(OpenTime, (string)OrderOpenTime() #ifdef __MQL5__ + "." + ::IntegerToString(OrderOpenTimeMsc() % 1000, 3, '0') #endif);
    ADD(Type, REPORT::TypeToString(OrderType()));
    ADD(Lots, REPORT::DoubleToString(OrderLots(), 2) +
              ((OrderType() <= OP_SELL) ? (" (" + REPORT::VolumeToString(OrderLots() * TickValue *
                                                                         (OrderOpenPrice() + OrderClosePrice())) + ")") : ""));
    ADD(Symbol, (OrderType() == OP_BALANCE) ? "" : OrderSymbol()
  #ifdef __MQL5__
      + (::SymbolInfoInteger(OrderSymbol(), SYMBOL_CUSTOM) ? " (" + ::SymbolInfoString(OrderSymbol(), SYMBOL_CURRENCY_PROFIT) + ")" : "")
  #endif // __MQL5__
        );
#ifdef REPORT_SLIPPAGE
//    ADD(OpenPriceRequest, REPORT::DoubleToString(REPORT::OrderOpenPriceRequest2(), digits));
//    ADD(ClosePriceRequest, REPORT::DoubleToString(REPORT::OrderClosePriceRequest2(), digits));
    const bool SlipPage = ((OrderOpenPrice() != REPORT::OrderOpenPriceRequest2()) || (OrderClosePrice() != REPORT::OrderClosePriceRequest2()));

    ADD(SlipPage, ((OrderType() <= OP_SELL) && SlipPage) ?
                   REPORT::NumToString(REPORT::ProfitToPips(REPORT::OrderOpenPriceRequest2(), OrderOpenPrice(), point)) + ", " +
                   REPORT::NumToString(REPORT::ProfitToPips(OrderClosePrice(), REPORT::OrderClosePriceRequest2(), point)) : "");
#endif // REPORT_SLIPPAGE
    ADD(OpenPrice, REPORT::DoubleToString(OrderOpenPrice(), digits));
    ADD(StopLoss, REPORT::DoubleToString(OrderStopLoss(), digits));
    ADD(TakeProfit, REPORT::DoubleToString(OrderTakeProfit(), digits));
    ADD(CloseTime, (OrderType() == OP_BALANCE) ? "" :(string)OrderCloseTime()
                   #ifdef __MQL5__ + "." + ::IntegerToString(OrderCloseTimeMsc() % 1000, 3, '0') #endif);
    ADD(ClosePrice, REPORT::DoubleToString(OrderClosePrice(), digits));
    ADD(Commission, REPORT::DoubleToString(OrderCommission(), 2));
    ADD(Swap, REPORT::DoubleToString(OrderSwap(), 2));
    ADD(Profit, ((OrderType() > OP_SELL) && (OrderType() != OP_BALANCE)) ? "" : (REPORT::NumToString(OrderProfit(), false)
#ifdef REPORT_SLIPPAGE
        + (SlipPage ? " (" + REPORT::NumToString(OrderLots() * (REPORT::OrderClosePriceRequest2() - REPORT::OrderOpenPriceRequest2()) * TickValue) + ")" : "")
#endif // REPORT_SLIPPAGE
        ));
    ADD(Comment, ANONYM(OrderComment()));
    ADD(Pips, (OrderType() <= OP_SELL) ? REPORT::NumToString(REPORT::ProfitToPips(OrderClosePrice(), OrderOpenPrice(), point))
#ifdef REPORT_SLIPPAGE
                      + (SlipPage ? " (" + REPORT::NumToString(REPORT::ProfitToPips(REPORT::OrderClosePriceRequest2(),
                                                                                        REPORT::OrderOpenPriceRequest2(), point)) + ")" : "")
#endif // REPORT_SLIPPAGE
                                         : "");

    ADD(LengthTime, (OrderType() == OP_BALANCE) ? "" :
#ifdef __MQL5__
        REPORT::LengthToString(OrderCloseTimeMsc() - OrderOpenTimeMsc())
#else // __MQL5__
        REPORT::LengthToString(OrderCloseTime() - OrderOpenTime())
#endif // __MQL5__
        );
/*
#ifdef __MQL5__
    ADD(LengthTime, (OrderType() == OP_BALANCE) ? "" : REPORT::LengthToString(OrderCloseTimeMsc() - OrderOpenTimeMsc()));
#else // __MQL5__
    ADD(LengthTime, (OrderType() == OP_BALANCE) ? "" : REPORT::LengthToString(OrderCloseTime() - OrderOpenTime()));
#endif // __MQL5__
*/
    return(Str);
  }

#undef ANONYM

  static string WriteTotal( string text, string val )
  {
    static int t_ind = 0;

    int cols = 5;
    string res = "<tr ";
    if (!(bool)(t_ind & 1)) res = res + "bgcolor=#E0E0E0 ";
    res= res + "align=right><td colspan=" + (string)cols + " align=right><b>" + text + "</b></td>";

    cols = REPORT::AmountFields - cols - 1;

    res = res + "<td colspan=" + (string)cols + " align=right style=\"color:blue\">" + val + "</td>";
    res = res + "<td></td>";
    res = res + "</tr>\n";

    t_ind++;

    return(res);
  }

#define MAX_LENGTH_STRING_ORDER 400

  static int Body( string &Res, const REPORT_FILTER &Filter, const bool Full = true )
  {
    double depo = 0;
    double comm = 0;
    double swap = 0;
    double profit = 0;
    double loss = 0;
    double max_win = 0;
    double max_loss = 0;

    int cons_win_cnt = 0;
    int cons_los_cnt = 0;
    double cons_win_sum = 0;
    double cons_los_sum = 0;

    int mc_winners_cnt = 0;
    int mc_losers_cnt = 0;
    double mc_winners_sum = 0;
    double mc_losers_sum = 0;

    int mc_profit_cnt = 0;
    int mc_loss_cnt = 0;
    double mc_profit_sum = 0;
    double mc_loss_sum = 0;

    double max_summ_pl = 0;
    double min_summ_pl = 0;
    double max_dd = 0;
    double max_dd2 = 0;

    double val;
    int ind = 0;
    int num = 1;
    int pos_cnt = 0;
    int neg_cnt = 0;

    int Total = OrdersHistoryTotal();

    string StrSum;

    ::StringInit(StrSum, Full ? Total * MAX_LENGTH_STRING_ORDER + 1 : 0);

    int AmountBalance = 0;
    int AmountPips = 1;

    double SumBalance = 0;
    double SumBalanceNoCommission = 0;

    int SumPips = 0;

    double SumGain = 0;
    double SumGainNoCommission = 0;

    double SumTurnOver = 0;

    ::ArrayResize(REPORT::Balance, Total);
    ::ArrayResize(REPORT::BalanceNoCommission, Total);

    ::ArrayResize(REPORT::Pips, Total + AmountPips);

    ::ArrayResize(REPORT::Gain, Total + AmountPips);
    ::ArrayResize(REPORT::GainNoCommission, Total + AmountPips);

    ::ArrayResize(REPORT::TurnOver, Total + AmountPips);

    REPORT::Pips[0] = 0;

    REPORT::Gain[0] = 0;
    REPORT::GainNoCommission[0] = 0;

    REPORT::TurnOver[0] = 0;

#ifdef REPORT_SLIPPAGE
    bool SlipPage = false;

    double SumBalanceNoSlip = 0;
    double SumBalanceNoSlipCommission = 0;

    int SumPipsNoSlip = 0;

    double SumGainNoSlip = 0;
    double SumGainNoSlipCommission = 0;

    ::ArrayResize(REPORT::BalanceNoSlip, Total);
    ::ArrayResize(REPORT::BalanceNoSlipCommission, Total);

    ::ArrayResize(REPORT::PipsNoSlip, Total + AmountPips);

    ::ArrayResize(REPORT::GainNoSlip, Total + AmountPips);
    ::ArrayResize(REPORT::GainNoSlipCommission, Total + AmountPips);

    REPORT::PipsNoSlip[0] = 0;

    REPORT::GainNoSlip[0] = 0;
    REPORT::GainNoSlipCommission[0] = 0;

    double SumProfitNoSlip = 0;

#endif // REPORT_SLIPPAGE
    double SumProfit = 0;
    double SumLots = 0;

    int Count = 0;

    // https://www.mql5.com/ru/forum/170953/page14#comment_10550116
    #define CLOSETIME_INDEX 0
    #define TICKET_INDEX 1
      long Tickets[][2];

    #ifdef __MQL5__
      static const bool Sort = false;
    #else // __MQL5__
      #ifdef __VIRTUAL__
        static const bool IsTester = ::MQLInfoInteger(MQL_TESTER);

        const bool Sort = !IsTester && !VIRTUAL::GetHandle();
      #else // __VIRTUAL__
        static const bool Sort = !::MQLInfoInteger(MQL_TESTER);
      #endif // __VIRTUAL__

      if (Sort)
      {
        int Amount = 0;

        for (int i = (::ArrayResize(Tickets, Total) >> 1) - 1; i >= 0; i--) // https://www.mql5.com/ru/forum/170953/page16#comment_10604064
          if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY) && Filter.Is())
          {
            Tickets[Amount][CLOSETIME_INDEX] = OrderCloseTime();
            Tickets[Amount++][TICKET_INDEX] = OrderTicket();
          }

        Total = ::ArrayResize(Tickets, Amount) >> 1; // https://www.mql5.com/ru/forum/170953/page16#comment_10604064
        ::ArraySort(Tickets);
      }
    #endif // __MQL5__

    for (int i = 0; i < Total; i++)
      if (Sort ? OrderSelect((int)Tickets[i][TICKET_INDEX], SELECT_BY_TICKET) : (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY) && Filter.Is())) // int - (Sort == true) only for MQL4.
    #undef TICKET_INDEX
    #undef CLOSETIME_INDEX
      {
        Count++;

        if ((OrderType() <= OP_SELL) || (OrderType() == OP_BALANCE))
        {
          if (OrderType() <= OP_SELL)
          {
            const double TickValue = REPORT::GetTickValue();
            const double point = ::SymbolInfoDouble(OrderSymbol(), SYMBOL_POINT);

            const int TmpPips = REPORT::ProfitToPips(OrderClosePrice(), OrderOpenPrice(), point);
            const double TmpTurnOver = 0;

            SumProfit += OrderProfit();
            SumLots += OrderLots();

            SumPips += (OrderType() == OP_BUY) ? TmpPips : -TmpPips;
            SumTurnOver += OrderLots() * TickValue * (OrderOpenPrice() + OrderClosePrice());

            REPORT::Pips[AmountPips] = SumPips;
            REPORT::TurnOver[AmountPips] = SumTurnOver;

#ifdef REPORT_SLIPPAGE
            const double Tmp = OrderLots() * (REPORT::OrderClosePriceRequest2() - REPORT::OrderOpenPriceRequest2()) * TickValue;
            const double TmpProfitNoSlip = (OrderType() == OP_BUY) ? Tmp : -Tmp;

            const int TmpPipsNoSlip = REPORT::ProfitToPips(REPORT::OrderClosePriceRequest2(), REPORT::OrderOpenPriceRequest2(), point);

            SumProfitNoSlip += TmpProfitNoSlip;

            SumBalanceNoSlip += TmpProfitNoSlip + OrderSwap() + OrderCommission();
            SumBalanceNoSlipCommission += TmpProfitNoSlip + OrderSwap();

            SumPipsNoSlip += (OrderType() == OP_BUY) ? TmpPipsNoSlip : -TmpPipsNoSlip;

            REPORT::PipsNoSlip[AmountPips] = SumPipsNoSlip;

            if (!SlipPage)
              SlipPage = ((OrderOpenPrice() != REPORT::OrderOpenPriceRequest2()) || (OrderClosePrice() != REPORT::OrderClosePriceRequest2()));
#endif // REPORT_SLIPPAGE

            AmountPips++;
          }
#ifdef REPORT_SLIPPAGE
          else
          {
            SumBalanceNoSlip += OrderProfit() + OrderSwap() + OrderCommission();
            SumBalanceNoSlipCommission += OrderProfit() + OrderSwap();
          }

          REPORT::BalanceNoSlip[AmountBalance] = SumBalanceNoSlip;
          REPORT::BalanceNoSlipCommission[AmountBalance] = SumBalanceNoSlipCommission;
#endif // REPORT_SLIPPAGE

          SumBalance += OrderProfit() + OrderCommission() + OrderSwap();
          SumBalanceNoCommission += OrderProfit() + OrderSwap();

          REPORT::Balance[AmountBalance] = SumBalance;
          REPORT::BalanceNoCommission[AmountBalance] = SumBalanceNoCommission;

          AmountBalance++;
        }

        if (Full)
        {
          StrSum += "<tr " + ((bool)(Count & 1) ? "" : "bgcolor=#E0E0E0 ") +
                 ((OrderType() == OP_BALANCE) ? "style=\"color:blue\" ": "") + "align=right>" + REPORT::OrderToString(Count, Filter) + "</tr>\n";

          if (OrderType() == OP_BALANCE)
            depo += OrderProfit();
          else
          {
            comm += OrderCommission();
            swap += OrderSwap();
            val = OrderProfit() + OrderCommission() + OrderSwap();

            if (val > 0)
            {
              pos_cnt++;
              profit += val;
              max_win = ::MathMax(max_win, val);

              cons_los_cnt = 0;
              cons_los_sum = 0;
              cons_win_cnt++;
              cons_win_sum += val;

              if (mc_winners_cnt < cons_win_cnt)
              {
                mc_winners_cnt = cons_win_cnt;
                mc_winners_sum = cons_win_sum;
              }
              else if (mc_winners_cnt == cons_win_cnt)
                mc_winners_sum = ::MathMax(mc_winners_sum, cons_win_sum);

              if (mc_profit_sum < cons_win_sum)
              {
                mc_profit_cnt = cons_win_cnt;
                mc_profit_sum = cons_win_sum;
              }

              max_summ_pl = ::MathMax(max_summ_pl, profit+loss);

            }
            else if (val < 0)
            {
              neg_cnt++;
              loss += val;
              max_loss = ::MathMin(max_loss, val);

              cons_win_cnt = 0;
              cons_win_sum = 0;
              cons_los_cnt++;
              cons_los_sum += val;

              if (mc_losers_cnt < cons_los_cnt)
              {
                mc_losers_cnt = cons_los_cnt;
                mc_losers_sum = cons_los_sum;
              }
              else if (mc_losers_cnt == cons_los_cnt)
                mc_losers_sum = ::MathMin(mc_losers_sum, cons_los_sum);

              if (mc_loss_sum > cons_los_sum)
              {
                mc_loss_cnt = cons_los_cnt;
                mc_loss_sum = cons_los_sum;
              }

              min_summ_pl = ::MathMin(min_summ_pl, profit + loss);

              if (max_dd < max_summ_pl - (profit + loss))
              {
                max_dd = max_summ_pl - (profit + loss);

                if (depo + max_summ_pl <= 0)
                  max_dd2 = 100;
                else
                  max_dd2 = 100 * max_dd / (depo + max_summ_pl);
              }
            }
          }
        }
      }

    ::ArrayResize(REPORT::Balance, AmountBalance);
    ::ArrayResize(REPORT::BalanceNoCommission, AmountBalance);

    ::ArrayResize(REPORT::Pips, AmountPips);
    ::ArrayResize(REPORT::TurnOver, AmountPips);

    //  
    ::ArrayResize(REPORT::Gain, AmountPips);
    ::ArrayResize(REPORT::GainNoCommission, AmountPips);

    ::ArrayInitialize(REPORT::Gain, 0);
    ::ArrayInitialize(REPORT::GainNoCommission, 0);
#ifdef REPORT_SLIPPAGE
    ::ArrayResize(REPORT::BalanceNoSlip, AmountBalance);
    ::ArrayResize(REPORT::BalanceNoSlipCommission, AmountBalance);

    ::ArrayResize(REPORT::PipsNoSlip, AmountPips);

    ::ArrayResize(REPORT::GainNoSlip, AmountPips);
    ::ArrayResize(REPORT::GainNoSlipCommission, AmountPips);

    //  
    ::ArrayInitialize(REPORT::GainNoSlip, 0);
    ::ArrayInitialize(REPORT::GainNoSlipCommission, 0);

    ::ArrayResize(REPORT::TurnOver, AmountPips);
#endif // REPORT_SLIPPAGE

    if (Full)
    {
      Res += StrSum;

      string Str = REPORT::Shablon;

      ADD(MagicNumber, "");
      ADD(N, "");
      ADD(Ticket, "");
      ADD(OpenTime, "");
      ADD(Type, "");
      ADD(Lots, SumLots ? ::DoubleToString(SumLots, 2) + " (" + REPORT::VolumeToString(SumTurnOver) +")" : "");
      ADD(Symbol, "");
  #ifdef REPORT_SLIPPAGE
  //    ADD(OpenPriceRequest, "");
  //    ADD(ClosePriceRequest, "");
      ADD(SlipPage, SlipPage ? REPORT::NumToString(SumPips - SumPipsNoSlip, false) +
                               " (" + REPORT::NumToString(SumProfit - SumProfitNoSlip, false) +
                               (comm ? " - " + ::DoubleToString(-100 * (SumProfit - SumProfitNoSlip) / comm, 1) + "%" : NULL) + ")": "");
  #endif // REPORT_SLIPPAGE
      ADD(OpenPrice, "");
      ADD(StopLoss, "");
      ADD(TakeProfit, "");
      ADD(CloseTime, "");
      ADD(ClosePrice, "");
      ADD(Commission, REPORT::DoubleToString(comm, 2));
      ADD(Swap, ::DoubleToString(swap, 2));
      ADD(Profit, REPORT::NumToString(SumProfit, false)
  #ifdef REPORT_SLIPPAGE
                + (SlipPage ? " (" + REPORT::NumToString(SumProfitNoSlip, false) + ")" : "")
  #endif // REPORT_SLIPPAGE
          );
      ADD(Comment, "");
      ADD(Pips, REPORT::NumToString(SumPips, false)
  #ifdef __MQL5__
                + (SlipPage ? " (" + REPORT::NumToString(SumPipsNoSlip, false) + ")" : "")
  #endif // __MQL5__
          );
      ADD(LengthTime, "");

  #undef ADD

      Res += "<tr align=right style=\"color:red\">" + Str + "</tr>\n" +
             REPORT::WriteTotal("Deposit/Withdrawal:", ::DoubleToString(depo, 2)) +
             REPORT::WriteTotal("Summary P/L:", ::DoubleToString(profit+loss, 2)) +
             REPORT::WriteTotal("Balance:", ::DoubleToString(depo+profit+loss, 2)) +
             "<tr><td>&nbsp;</td></tr>\n" +
             REPORT::WriteTotal("Winning trades:", "("+(string)pos_cnt+")  " + ::DoubleToString(profit, 2)) +
             REPORT::WriteTotal("Losing trades:", "("+(string)neg_cnt+")  " + ::DoubleToString(loss, 2)) +
             REPORT::WriteTotal("Max summary P/L:", ::DoubleToString(max_summ_pl, 2)) +
             REPORT::WriteTotal("Largest winning trade:", ::DoubleToString(max_win, 2)) +
             REPORT::WriteTotal("Largest losing trade:", ::DoubleToString(max_loss, 2)) +
             REPORT::WriteTotal("Max consecutive winners:", (string)mc_winners_cnt +"  ("+ ::DoubleToString(mc_winners_sum, 2) +")") +
             REPORT::WriteTotal("Max consecutive losers:", (string)mc_losers_cnt +"  ("+ ::DoubleToString(mc_losers_sum, 2) +")") +
             REPORT::WriteTotal("Max consecutive profit:", ::DoubleToString(mc_profit_sum, 2) +"  ("+ (string)mc_profit_cnt +")") +
             REPORT::WriteTotal("Max consecutive loss:", ::DoubleToString(mc_loss_sum, 2) +"  ("+ (string)mc_loss_cnt +")") +
             REPORT::WriteTotal("Absolute drawdown:", "*") +
             REPORT::WriteTotal("Max drawdown:", ::DoubleToString(max_dd, 2) +"  ("+ ::DoubleToString(max_dd2, 2) +"%)") +
             REPORT::WriteTotal("Profit factor:", loss ? ::DoubleToString(::MathAbs(profit/loss), 2) : "*") +
             REPORT::WriteTotal("Avg. profit factor:", (bool)(loss * pos_cnt) ? ::DoubleToString(::MathAbs((profit*neg_cnt)/(loss*pos_cnt)), 2) : "*") +
             REPORT::WriteTotal("Risk factor:", max_dd ? ::DoubleToString((profit+loss)/max_dd, 2) : "*") +
             "<tr><td>&nbsp;</td></tr>\n";

      REPORT::Tail(Res);
    }

    return(Total);
  }

#undef MAX_LENGTH_STRING_ORDER

  static void Tail( string &Res ) {
    Res += "</table>\n" +
           "<div style=\"font: 16pt Times New Roman\"><b>* * *</b></div>\n" +
           "</font></div>\n" +
           "</body></html>\n";
  }

#ifdef REPORT_GRAPHICS
  static bool FolderMove( const string FolderNameSrc, const string FolderNameDst, const int Common_Flag = 0, const int Mode_Flags = FILE_REWRITE )
  {
    if (FolderNameSrc == FolderNameDst)
      return(false);

    string FileName;
    const long handle = ::FileFindFirst(FolderNameSrc + "\\*", FileName, Common_Flag);

    bool Res = false;

    if (handle != INVALID_HANDLE)
    {
      do
      {
        const string TmpFileNameSrc = FolderNameSrc + "\\" + FileName;
        const string TmpFileNameDst = FolderNameDst + "\\" + FileName;

        if (::FileIsExist(TmpFileNameSrc, Common_Flag))
          Res = ::FileMove(TmpFileNameSrc, Common_Flag, TmpFileNameDst, Mode_Flags);
        else
        {
          const string TmpFileNameSrc2 = ::StringSubstr(TmpFileNameSrc, 0, ::StringLen(TmpFileNameSrc) - 1);
          const string TmpFileNameDst2 = ::StringSubstr(TmpFileNameDst, 0, ::StringLen(TmpFileNameDst) - 1);

          if (!FolderMove(TmpFileNameSrc2, TmpFileNameDst2, Common_Flag, Mode_Flags))
            Res = ::FolderCreate(TmpFileNameDst2, Mode_Flags & FILE_COMMON);
        }
      }
      while (::FileFindNext(handle, FileName));

      ::FileFindClose(handle);
    }

    return(::FolderDelete(FolderNameSrc, Common_Flag) && Res);
  }

#define MIN_WIDTH 10
  static string GraphPlot( const double &Y[], int Width = 0, int Height = 0,
                     const ENUM_CURVE_TYPE Type = CURVE_NONE,
                     const string CurveName = NULL, string ObjName = NULL )
  {
    Width = Width ? Width : (int)::ChartGetInteger(0, CHART_WIDTH_IN_PIXELS);
    Height = Height ? Height : (int)::ChartGetInteger(0, CHART_HEIGHT_IN_PIXELS);
    ObjName = (ObjName == NULL) ? __FUNCTION__ : ObjName;

    CGraphic Graphic;

    const bool Res = (::ObjectFind(0, ObjName) >= 0) ? Graphic.Attach(0, ObjName) : Graphic.Create(0, ObjName, 0, 0, 0, Width, Height);

    if (Res)
    {
      const int Size = ::ArraySize(Y);

      Graphic.CurveAdd(Y, ((Type == CURVE_NONE) && Size) ? ((Width / Size < MIN_WIDTH) ? CURVE_LINES : CURVE_POINTS_AND_LINES) : Type, CurveName);

      Graphic.CurvePlotAll();
      Graphic.Update();
    }

    return (Res ? Graphic.ChartObjectName() : NULL);
  }

  static string GraphPlot( const double &Y1[], const double &Y2[],
                           int Width = 0, int Height = 0, const ENUM_CURVE_TYPE Type = CURVE_NONE,
                           const string CurveName1 = NULL, const string CurveName2 = NULL, string ObjName = NULL )
  {
    Width = Width ? Width : (int)::ChartGetInteger(0, CHART_WIDTH_IN_PIXELS);
    Height = Height ? Height : (int)::ChartGetInteger(0, CHART_HEIGHT_IN_PIXELS);
    ObjName = (ObjName == NULL) ? __FUNCTION__ : ObjName;

    CGraphic Graphic;

    const bool Res = (::ObjectFind(0, ObjName) >= 0) ? Graphic.Attach(0, ObjName) : Graphic.Create(0, ObjName, 0, 0, 0, Width, Height);

    if (Res)
    {
      const int Size1 = ::ArraySize(Y1);
      const int Size2 = ::ArraySize(Y2);

      Graphic.CurveAdd(Y1, ((Type == CURVE_NONE) && Size1) ? ((Width / Size1 < MIN_WIDTH) ? CURVE_LINES : CURVE_POINTS_AND_LINES) : Type, CurveName1);
      Graphic.CurveAdd(Y2, ((Type == CURVE_NONE) && Size2) ? ((Width / Size2 < MIN_WIDTH) ? CURVE_LINES : CURVE_POINTS_AND_LINES) : Type, CurveName2);

      Graphic.CurvePlotAll();
      Graphic.Update();
    }

    return (Res ? Graphic.ChartObjectName() : NULL);
  }

  static string GraphPlot( const double &Y1[], const double &Y2[], const double &Y3[], const double &Y4[],
                           int Width = 0, int Height = 0, const ENUM_CURVE_TYPE Type = CURVE_NONE,
                           const string CurveName1 = NULL, const string CurveName2 = NULL,
                           const string CurveName3 = NULL, const string CurveName4 = NULL, string ObjName = NULL )
  {
    Width = Width ? Width : (int)::ChartGetInteger(0, CHART_WIDTH_IN_PIXELS);
    Height = Height ? Height : (int)::ChartGetInteger(0, CHART_HEIGHT_IN_PIXELS);
    ObjName = (ObjName == NULL) ? __FUNCTION__ : ObjName;

    CGraphic Graphic;

    const bool Res = (::ObjectFind(0, ObjName) >= 0) ? Graphic.Attach(0, ObjName) : Graphic.Create(0, ObjName, 0, 0, 0, Width, Height);

    if (Res)
    {
      const int Size1 = ::ArraySize(Y1);
      const int Size2 = ::ArraySize(Y2);
      const int Size3 = ::ArraySize(Y3);
      const int Size4 = ::ArraySize(Y4);

      Graphic.CurveAdd(Y1, ((Type == CURVE_NONE) && Size1) ? ((Width / Size1 < MIN_WIDTH) ? CURVE_LINES : CURVE_POINTS_AND_LINES) : Type, CurveName1);
      Graphic.CurveAdd(Y2, ((Type == CURVE_NONE) && Size2) ? ((Width / Size2 < MIN_WIDTH) ? CURVE_LINES : CURVE_POINTS_AND_LINES) : Type, CurveName2);
      Graphic.CurveAdd(Y3, ((Type == CURVE_NONE) && Size3) ? ((Width / Size3 < MIN_WIDTH) ? CURVE_LINES : CURVE_POINTS_AND_LINES) : Type, CurveName3);
      Graphic.CurveAdd(Y4, ((Type == CURVE_NONE) && Size4) ? ((Width / Size4 < MIN_WIDTH) ? CURVE_LINES : CURVE_POINTS_AND_LINES) : Type, CurveName4);

      Graphic.CurvePlotAll();
      Graphic.Update();
    }

    return (Res ? Graphic.ChartObjectName() : NULL);
  }
#undef MIN_WIDTH

  static bool BitmapObjectToFile( const long chartID, const string ObjName, const string FileName )
  {
    bool Res = (ObjName != NULL) && (FileName != NULL) && (::ObjectFind(chartID, ObjName) >= 0) &&
               ((ENUM_OBJECT)::ObjectGetInteger(chartID, ObjName, OBJPROP_TYPE) == OBJ_BITMAP_LABEL);

    if (Res)
    {
      //  MT4   .
      #ifdef __MQL4__
        const string StrComment = ::ChartGetString(0, CHART_COMMENT);

        ::ChartSetString(0, CHART_COMMENT, "");
      #endif // __MQL4__

      const bool DateScale = (bool)::ChartGetInteger(chartID, CHART_SHOW_DATE_SCALE);
      const bool PriceScale = (bool)::ChartGetInteger(chartID, CHART_SHOW_PRICE_SCALE);

      ::ChartSetInteger(chartID, CHART_SHOW_DATE_SCALE, false);
      ::ChartSetInteger(chartID, CHART_SHOW_PRICE_SCALE, false);

      const int X = (int)::ObjectGetInteger(chartID, ObjName, OBJPROP_XDISTANCE);
      const int Y = (int)::ObjectGetInteger(chartID, ObjName, OBJPROP_YDISTANCE);

      ::ObjectSetInteger(chartID, ObjName, OBJPROP_XDISTANCE, 0);
      ::ObjectSetInteger(chartID, ObjName, OBJPROP_YDISTANCE, 0);

      const int Width = (int)::ObjectGetInteger(chartID, ObjName, OBJPROP_XSIZE);
      const int Height = (int)::ObjectGetInteger(chartID, ObjName, OBJPROP_YSIZE);

      Res = ::ChartScreenShot(chartID, FileName, Width, Height, ALIGN_LEFT);

      ::ObjectSetInteger(chartID, ObjName, OBJPROP_XDISTANCE, X);
      ::ObjectSetInteger(chartID, ObjName, OBJPROP_YDISTANCE, Y);

      ::ChartSetInteger(chartID, CHART_SHOW_DATE_SCALE, DateScale);
      ::ChartSetInteger(chartID, CHART_SHOW_PRICE_SCALE, PriceScale);

    #ifdef __MQL4__
      ::ChartSetString(0, CHART_COMMENT, StrComment);
    #endif // __MQL4__

      ::ChartRedraw(chartID);
    }

    return(Res);
  }

  static string ToChart( const double &Y[], const string CurveName = NULL, const int Width = 0, const int Height = 0,
                         const ENUM_CURVE_TYPE Type = CURVE_NONE, const string FileName = NULL )
  {
    const string ObjName = REPORT::GraphPlot(Y, Width, Height, Type, CurveName);

    REPORT::BitmapObjectToFile(0, ObjName, FileName);

    return(ObjName);
  }

  static string ToChart( const double &Y1[], const string CurveName1,
                         const double &Y2[], const string CurveName2,
                         const int Width = 0, const int Height = 0,
                         const ENUM_CURVE_TYPE Type = CURVE_NONE, const string FileName = NULL )
  {
    const string ObjName = REPORT::GraphPlot(Y1, Y2, Width, Height, Type, CurveName1, CurveName2);

    REPORT::BitmapObjectToFile(0, ObjName, FileName);

    return(ObjName);
  }

  static string ToChart( const double &Y1[], const string CurveName1,
                         const double &Y2[], const string CurveName2,
                         const double &Y3[], const string CurveName3,
                         const double &Y4[], const string CurveName4,
                         const int Width = 0, const int Height = 0,
                         const ENUM_CURVE_TYPE Type = CURVE_NONE, const string FileName = NULL )
  {
    const string ObjName = REPORT::GraphPlot(Y1, Y2, Y3, Y4, Width, Height, Type, CurveName1, CurveName2, CurveName3, CurveName4);

    REPORT::BitmapObjectToFile(0, ObjName, FileName);

    return(ObjName);
  }
#endif // REPORT_GRAPHICS

#ifdef // __MQL5__
  static string DiapasonToString( const string Name )
  {
    bool Enable;

    long lValue;
    long lStart;
    long lStep;
    long lStop;

    double dValue;
    double dStart;
    double dStep;
    double dStop;

    return((::ParameterGetRange(Name, Enable, lValue, lStart, lStep, lStop) && Enable &&
            ::ParameterGetRange(Name, Enable, dValue, dStart, dStep, dStop)) ?
            " (" +(((lStart != dStart) || (lStep != dStep) || (lStop != dStop)) ?
            ((string)dStart + ", " + (string)dStep + ", " + (string)dStop) :
            ((string)lStart + ", " + (string)lStep + ", " + (string)lStop))  + ")" : "");
  }

  static string DiapasonToSet( const string Name )
  {
    bool Enable;

    long lValue;
    long lStart;
    long lStep;
    long lStop;

    double dValue;
    double dStart;
    double dStep;
    double dStop;

    return((::ParameterGetRange(Name, Enable, lValue, lStart, lStep, lStop) &&
            ::ParameterGetRange(Name, Enable, dValue, dStart, dStep, dStop)) ?
            "||" +(((lStart != dStart) || (lStep != dStep) || (lStop != dStop)) ?
            ((string)dStart + "||" + (string)dStep + "||" + (string)dStop) :
            ((string)lStart + "||" + (string)lStep + "||" + (string)lStop))  + "||" +
            (Enable ? "Y" : "N"): "");
  }
#endif // __MQL5__

public:
  static int Calculate( const REPORT_FILTER &Filter, const bool Full = false )
  {
    if (Full)
      REPORT::Head(REPORT::Report, Filter);

    return(REPORT::Body(REPORT::Report, Filter, Full));
  }

  static bool ToFile( const string FileName  = "Report.htm" )
  {
    REPORT_FILTER Filter;

    return(REPORT::ToFile(FileName, Filter));
  }

  static bool ToFile( const string FileName, const REPORT_FILTER &Filter )
  {
    const int handle = ::FileOpen(FileName, FILE_WRITE | FILE_TXT | FILE_ANSI);
    const bool Res = (handle != INVALID_HANDLE);

    if (Res)
    {
      const ulong StartTime = ::GetMicrosecondCount();

      REPORT::Calculate(Filter, true);

    #ifdef REPORT_GRAPHICS
      if (::MQLInfoInteger(MQL_VISUAL_MODE) || (!::MQLInfoInteger(MQL_TESTER)))
      {
        string ImageName = FileName;
        int Pos = 0;

        while ((Pos = ::StringFind(ImageName, "\\")) >= 0)
          ImageName = ::StringSubstr(ImageName, Pos + 1);

        ::StringReplace(REPORT::Report, "::BALANCE::", ImageName + ".png");
        ::StringReplace(REPORT::Report, "::PIPS::", ImageName + "_pips.png");
        ::StringReplace(REPORT::Report, "::GAIN::", ImageName + "_gain.png");
        ::StringReplace(REPORT::Report, "::TURNOVER::", ImageName + "_turnover.png");

        REPORT::ToChart(REPORT_BALANCE, WIDTH, HEIGHT, CURVE_NONE, FileName + ".png", false);
        REPORT::ToChart(REPORT_PIPS, WIDTH, HEIGHT, CURVE_NONE, FileName + "_pips.png", false);
        REPORT::ToChart(REPORT_GAIN, WIDTH, HEIGHT, CURVE_NONE, FileName + "_gain.png", false);
        const string ObjName = REPORT::ToChart(REPORT_TURNOVER, WIDTH, HEIGHT, CURVE_NONE, FileName + "_turnover.png", false);

        if (ObjName != NULL)
        {
          ::ObjectDelete(0, ObjName);

          ::ChartRedraw(0);
        }
      }
    #endif // REPORT_GRAPHICS

      ::StringReplace(REPORT::Report, "::TIME::", (string)::TimeLocal());
      ::StringReplace(REPORT::Report, "::GENERATE::", ::DoubleToString((GetMicrosecondCount() - StartTime) / 1e6, 3));
      ::StringReplace(REPORT::Report, "::SIZE::", ::DoubleToString( ::StringLen(REPORT::Report) / 1024.0, 1));

      ::FileWrite(handle, REPORT::Report);
      ::FileClose(handle);

    #ifdef REPORT_BROWSER
      if (::MQLInfoInteger(MQL_DLLS_ALLOWED))
      {
        if (::MQLInfoInteger(MQL_TESTER))
        {
          if (!::MQLInfoInteger(MQL_OPTIMIZATION))
            ShellExecuteW(0, "Open", BASEPATH_TESTER + FileName, NULL, NULL, 3);
        }
        else
          ShellExecuteW(0, "Open", BASEPATH + FileName, NULL, NULL, 3);
      }
    #endif // REPORT_BROWSER
    }

    return(Res);
  }

#ifdef REPORT_GRAPHICS
  static string ToChart( const ENUM_REPORT_CHART ChartType = REPORT_BALANCE, const int Width = 0, const int Height = 0,
                         const ENUM_CURVE_TYPE Type = CURVE_NONE, const string FileName = NULL, const bool Calculate = true )
  {
    string ObjName = NULL;

    if (!::MQLInfoInteger(MQL_TESTER) || ::MQLInfoInteger(MQL_VISUAL_MODE))
    {
      if (Calculate)
      {
        REPORT_FILTER Filter;

        REPORT::Calculate(Filter);
      }

      if (ChartType == REPORT_BALANCE)
        ObjName = REPORT::ToChart(REPORT::Balance, "Balance",
  #ifdef REPORT_SLIPPAGE
                                  REPORT::BalanceNoSlip, "w/o SlipPages",
  #endif // REPORT_SLIPPAGE
                                  REPORT::BalanceNoCommission, "No Commission",
  #ifdef REPORT_SLIPPAGE
                                  REPORT::BalanceNoSlipCommission, "NoSlipComm",
  #endif // REPORT_SLIPPAGE
                                  Width, Height, Type, FileName);
      else if (ChartType == REPORT_PIPS)
        ObjName = REPORT::ToChart(REPORT::Pips, "Pips",
  #ifdef REPORT_SLIPPAGE
                                  REPORT::PipsNoSlip, "w/o SlipPages",
  #endif // REPORT_SLIPPAGE
                                  Width, Height, Type, FileName);
      else if (ChartType == REPORT_GAIN)
        ObjName = REPORT::ToChart(REPORT::Gain, "Gain",
  #ifdef REPORT_SLIPPAGE
                                  REPORT::GainNoSlip, "w/o SlipPages",
  #endif // REPORT_SLIPPAGE
                                  REPORT::GainNoCommission, "No Commission",
  #ifdef REPORT_SLIPPAGE
                                  REPORT::GainNoSlipCommission, "NoSlipComm",
  #endif // REPORT_SLIPPAGE
                                  Width, Height, Type, FileName);
      else if (ChartType == REPORT_TURNOVER)
        ObjName = REPORT::ToChart(REPORT::TurnOver, "Turnover", Width, Height, Type, FileName);
    }

    return(ObjName);
  }
#endif // REPORT_GRAPHICS

#ifdef __MQL5__
#ifdef REPORT_TESTER

#define PATH_REPORT ("Reports\\" + REPORT::TimeName + ::MQLInfoString(MQL_PROGRAM_NAME))
#define PATH_FILES (::TerminalInfoString(TERMINAL_DATA_PATH) + "\\MQL5\\Files\\")

  REPORT( void )
  {
    if (::MQLInfoInteger(MQL_FRAME_MODE))
    {
      if (::Report)
        ::Comment("Optimizing...\n" + PATH_FILES + PATH_REPORT + "\\\n" +
                  (string)REPORT::OnTesterPasses + " reports.");
      else
        ::ChartClose();
    }
  }

  ~REPORT( void )
  {
    if (::Report)
    {
       const ulong StartTime = ::GetMicrosecondCount();

#ifndef __TESTERBENCH__
      if (::MQLInfoInteger(MQL_OPTIMIZATION))
      {
        REPORT_FILTER Filter;
        REPORT::Calculate(Filter, true);

        OrderSelect(0, SELECT_BY_POS, MODE_HISTORY); // Always true

      #ifdef __TYPETOBYTES__
        CONTAINER<uchar> Container;

        Container[0] = REPORT::Report;
        Container[1] = REPORT::Balance;
        Container[2] = REPORT::BalanceNoSlip;
        Container[3] = REPORT::BalanceNoCommission;
        Container[4] = REPORT::BalanceNoSlipCommission;
        Container[5] = REPORT::Pips;
        Container[6] = REPORT::PipsNoSlip;
        Container[7] = REPORT::Gain;
        Container[8] = REPORT::GainNoSlip;
        Container[9] = REPORT::GainNoCommission;
        Container[10] = REPORT::GainNoSlipCommission;
        Container[11] = REPORT::TurnOver;

        ::FrameAdd(::TimeToString(OrderOpenTime(), TIME_DATE), ::TimeCurrent(), (::GetMicrosecondCount() - StartTime) / 1e6, Container.Data);
      #else  // __TYPETOBYTES__
        uchar Data[];

        ::StringToCharArray(REPORT::Report, Data);

        ::FrameAdd(::TimeToString(OrderOpenTime(), TIME_DATE), ::TimeCurrent(), (::GetMicrosecondCount() - StartTime) / 1e6, Data);
      #endif // __TYPETOBYTES__
      }
      else
#endif // __TESTERBENCH__
      if (::MQLInfoInteger(MQL_FRAME_MODE))
      {
        if (REPORT::OnTesterPasses > 0)
        {
          const string PathReport = PATH_REPORT + " (" + REPORT::TimeBegin + " - " + ::TimeToString(REPORT::TimeEnd + 24 * 3600, TIME_DATE) + ")";

          REPORT::FolderMove(PATH_REPORT, PathReport);

          ::Print("Report's folder (copy-paste for SET-files loading)\n" +
                  PATH_FILES + PathReport + "\\\n" +
                  (string)REPORT::OnTesterPasses + " reports.");
        }
      }
      else if (::MQLInfoInteger(MQL_TESTER))
      {
        const string FileName = PATH_REPORT + "_Report.htm";

        if (REPORT::ToFile(FileName))
          ::Print(PATH_FILES + FileName + " - Done!");
      }
    }
  }

  static void OnTesterPass( void )
  {
    if (::Report)
    {
      ulong Pass;
      string Name;
      long ID;
      double Value;

    #ifdef __TYPETOBYTES__
      CONTAINER<uchar> Container;

      while (::FrameNext(Pass, Name, ID, Value, Container.Data))
    #else // __TYPETOBYTES__
      uchar Data[];

      while (::FrameNext(Pass, Name, ID, Value, Data))
    #endif // __TYPETOBYTES__
      {
        if (ID > REPORT::TimeEnd)
          REPORT::TimeEnd = (datetime)ID;

        const string FileName = ::IntegerToString(Pass, 5, '0');
        const int handle = ::FileOpen(PATH_REPORT + "\\" + FileName + ".htm", FILE_WRITE | FILE_TXT | FILE_ANSI);

        if (handle != INVALID_HANDLE)
        {
    #ifdef __TYPETOBYTES__
        ::ArrayFree(REPORT::Balance);
        ::ArrayFree(REPORT::BalanceNoSlip);
        ::ArrayFree(REPORT::BalanceNoCommission);
        ::ArrayFree(REPORT::BalanceNoSlipCommission);
        ::ArrayFree(REPORT::Pips);
        ::ArrayFree(REPORT::PipsNoSlip);
        ::ArrayFree(REPORT::Gain);
        ::ArrayFree(REPORT::GainNoSlip);
        ::ArrayFree(REPORT::GainNoCommission);
        ::ArrayFree(REPORT::GainNoSlipCommission);
        ::ArrayFree(REPORT::TurnOver);


        Container[0].Get(REPORT::Report);
        Container[1].Get(REPORT::Balance);
        Container[2].Get(REPORT::BalanceNoSlip);
        Container[3].Get(REPORT::BalanceNoCommission);
        Container[4].Get(REPORT::BalanceNoSlipCommission);
        Container[5].Get(REPORT::Pips);
        Container[6].Get(REPORT::PipsNoSlip);
        Container[7].Get(REPORT::Gain);
        Container[8].Get(REPORT::GainNoSlip);
        Container[9].Get(REPORT::GainNoCommission);
        Container[10].Get(REPORT::GainNoSlipCommission);
        Container[11].Get(REPORT::TurnOver);

        const string ImageNamePips = FileName + "_pips.png";
        ::StringReplace(REPORT::Report, "::PIPS::", ImageNamePips);
        REPORT::ToChart(REPORT_PIPS, WIDTH, HEIGHT, CURVE_NONE, PATH_REPORT + "\\" + ImageNamePips, false);

        const string ImageNameGain = FileName + "_gain.png";
        ::StringReplace(REPORT::Report, "::GAIN::", ImageNameGain);
        REPORT::ToChart(REPORT_GAIN, WIDTH, HEIGHT, CURVE_NONE, PATH_REPORT + "\\" + ImageNameGain, false);

        const string ImageNameTurnOver = FileName + "_turnover.png";
        ::StringReplace(REPORT::Report, "::TURNOVER::", ImageNameTurnOver);
        REPORT::ToChart(REPORT_TURNOVER, WIDTH, HEIGHT, CURVE_NONE, PATH_REPORT + "\\" + ImageNameTurnOver, false);

        const string ImageNameBalance = FileName + ".png";
        ::StringReplace(REPORT::Report, "::BALANCE::", ImageNameBalance);
        REPORT::ToChart(REPORT_BALANCE, WIDTH, HEIGHT, CURVE_NONE, PATH_REPORT + "\\" + ImageNameBalance, false);

    #else // __TYPETOBYTES__
          REPORT::Report = ::CharArrayToString(Data);
    #endif // __TYPETOBYTES__

          string Parameters[];
          int Count;
          string StrSet = "";

          if (::FrameInputs(Pass, Parameters, Count))
          {
            const REPORT_FILTER Filter;

            if (!Filter.Anonym)
            {
              string StrParam = "<div align=left style=\"color:red\">Input Parameters:</div>\n";

              for (int i = 0; i < Count; i++)
              {
                const string InputName = ::StringSubstr(Parameters[i], 0, ::StringFind(Parameters[i], "="));

                if (Parameters[i] != "Report=1")
                  StrParam += "<div align=left>" + Parameters[i] + REPORT::DiapasonToString(InputName) + "</div>\n";

                StrSet += Parameters[i] + REPORT::DiapasonToSet(InputName) + "\n";
              }

              ::StringReplace(REPORT::Report, "Input Parameters:", StrParam);
            }
            ::StringReplace(REPORT::Report, "Tester Pass:", "Tester Pass: " + (string)Pass);
          }

          ::StringReplace(REPORT::Report, "::TIME::", (string)::TimeLocal());
          ::StringReplace(REPORT::Report, "::GENERATE::", ::DoubleToString(Value, 3));
          ::StringReplace(REPORT::Report, "::SIZE::", ::DoubleToString( ::StringLen(REPORT::Report) / 1024.0, 1));

          if (::FileWrite(handle, REPORT::Report))
          {
            REPORT::OnTesterPasses++;

            REPORT::TimeBegin = Name;

            ::Comment("Optimizing...\n" + PATH_FILES + PATH_REPORT + "\\\n" +
                      (string)REPORT::OnTesterPasses + " reports.");
          }

          ::FileClose(handle);

          const int handleSet = ::FileOpen(PATH_REPORT + "\\" + FileName + ".set", FILE_WRITE | FILE_TXT | FILE_UNICODE);

          if (handleSet != INVALID_HANDLE)
          {
            ::FileWrite(handleSet, StrSet);

            ::FileClose(handleSet);
          }
        }
      }
    }

    return;
  }

#undef PATH_REPORT
#undef PATH_FILES

#endif // REPORT_TESTER
#else // __MQL5__
#ifdef REPORT_TESTER
  ~REPORT( void )
  {
    if (::Report && ::MQLInfoInteger(MQL_TESTER) && !::MQLInfoInteger(MQL_OPTIMIZATION) && REPORT::ToFile())
      ::Print(::TerminalInfoString(TERMINAL_PATH) + "\\tester\\Files\\Report.htm - Done!");
  }
#endif // REPORT_TESTER
#endif // __MQL5__

  static string OrderToString( void )
  {
    const string Types[] = {"buy", "sell", "buy limit", "sell limit", "buy stop", "sell stop", "balance"};
    const int digits = (int)::SymbolInfoInteger(OrderSymbol(), SYMBOL_DIGITS);
    const double point = ::SymbolInfoDouble(OrderSymbol(), SYMBOL_POINT);

    return("#" + (string)OrderTicket() + " " +
          (string)OrderOpenTime() +
        #ifdef __MQL5__
          "." + ::IntegerToString(OrderOpenTimeMsc() % 1000, 3, '0') + " " +
        #else // __MQL5__
          #ifdef __VIRTUAL__
            "." + ::IntegerToString(OrderOpenTimeMsc() % 1000, 3, '0') + " " +
          #else // __VIRTUAL__
            " " +
          #endif // __VIRTUAL__
        #endif // __MQL5__
          ((OrderType() < ::ArraySize(Types)) ? Types[OrderType()] : "unknown") +" " +
          ::DoubleToString(OrderLots(),2) + " " +
          OrderSymbol()+ " " +
          ::DoubleToString(OrderOpenPrice(), digits) + " " +
          ::DoubleToString(OrderStopLoss(), digits) + " " +
          ::DoubleToString(OrderTakeProfit(), digits) + " " +
          ((OrderCloseTime() > 0) ? ((string)OrderCloseTime() +
        #ifdef __MQL5__
          "." + ::IntegerToString(OrderCloseTimeMsc() % 1000, 3, '0') + " "
        #else // __MQL5__
          #ifdef __VIRTUAL__
            "." + ::IntegerToString(OrderCloseTimeMsc() % 1000, 3, '0') + " "
          #else // __VIRTUAL__
            " "
          #endif // __VIRTUAL__
        #endif // __MQL5__
          ) : NULL) +
          ::DoubleToString(OrderClosePrice(), digits) + " " +
          ::DoubleToString(OrderCommission(), 2) + " " +
          ::DoubleToString(OrderSwap(), 2) + " " +
          ::DoubleToString(OrderProfit(),2) + " " +
          ((OrderComment() == "") ? NULL : (OrderComment() + " ")) +
          (string)OrderMagicNumber() +
          (((OrderExpiration() > 0) ? (" expiration " + (string)OrderExpiration()) : NULL)) +
          ((OrderType() <= OP_SELL) ? ": " + REPORT::NumToString(REPORT::ProfitToPips(OrderClosePrice(), OrderOpenPrice(), point))
        #ifdef REPORT_SLIPPAGE
                      + " (" + REPORT::NumToString(REPORT::ProfitToPips(REPORT::OrderClosePriceRequest2(),
                                                                        REPORT::OrderOpenPriceRequest2(), point)) + ")"
        #endif // REPORT_SLIPPAGE
                                    : NULL) + " - " +
        REPORT::LengthToString((OrderCloseTime() ? OrderCloseTime() : ::TimeCurrent()) - OrderOpenTime()));
  }

  static string OrdersToString( const string Symb, const MAGIC_TYPE Magic = 0, int LastHistoryOrders = 0, const bool Pending = true )
  {
    const int Total = OrdersTotal();
    MqlTick Tick;

    string Str =
               #ifdef __VIRTUAL__
                 (VIRTUAL::GetHandle() ? "VIRTUAL_" + (string)VIRTUAL::GetHandle() : "REAL") + ":\n\n" +
               #endif // __VIRTUAL__
                 (::SymbolInfoTick(Symb, Tick) ? REPORT::TickToString(Tick) + "\n\n" : NULL);

    for (int i = 0; i < Total; i++)
      if (OrderSelect(i, SELECT_BY_POS) && (OrderSymbol() == Symb) && (OrderMagicNumber() == Magic))
        Str += REPORT::OrderToString() + "\n";

    if (LastHistoryOrders > 0)
    {
    // https://www.mql5.com/ru/forum/170953/page14#comment_10550116
    #define CLOSETIME_INDEX 0
    #define TICKET_INDEX 1
      long Tickets[][2];

    #ifdef __MQL5__
      static const bool Sort = false;
    #else // __MQL5__
      #ifdef __VIRTUAL__
        static const bool IsTester = ::MQLInfoInteger(MQL_TESTER);

        const bool Sort = !IsTester && !VIRTUAL::GetHandle();
      #else // __VIRTUAL__
        static const bool Sort = !::MQLInfoInteger(MQL_TESTER);
      #endif // __VIRTUAL__

      if (Sort)
      {
        ::ArrayResize(Tickets, LastHistoryOrders);
        int Amount = 0;

        for (int i = OrdersHistoryTotal() - 1; (i >= 0) && (Amount < LastHistoryOrders); i--)
          if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY) && (Pending || (OrderType() <= OP_SELL)) && (OrderSymbol() == Symb) && (OrderMagicNumber() == Magic))
          {
            Tickets[Amount][CLOSETIME_INDEX] = OrderCloseTime();
            Tickets[Amount++][TICKET_INDEX] = OrderTicket();
          }

        ::ArrayResize(Tickets, Amount);
        ::ArraySort(Tickets);
      }
    #endif // __MQL5__

      if (Sort)
      {
        for (int i = (::ArraySize(Tickets) >> 1) - 1; i >= 0; i--) // https://www.mql5.com/ru/forum/170953/page16#comment_10604064
          if (OrderSelect((int)Tickets[i][TICKET_INDEX], SELECT_BY_TICKET)) // int - (Sort == true) only for MQL4.
            Str += "\n" + REPORT::OrderToString();
      }
      else
        for (int i = OrdersHistoryTotal() - 1; (i >= 0) && LastHistoryOrders; i--)
          if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY) && (Pending || (OrderType() <= OP_SELL)) && (OrderSymbol() == Symb) && (OrderMagicNumber() == Magic))
          {
            Str += "\n" + REPORT::OrderToString();

            LastHistoryOrders--;
          }

    #undef TICKET_INDEX
    #undef CLOSETIME_INDEX
     }

    return(Str);
  }
};

#define FIELD(A) ("<td>" + #A + "</td>" + REPORT::AddField())

int REPORT::AmountFields = 0;
const string REPORT:: Shablon = FIELD(N) + FIELD(Ticket) + FIELD(OpenTime) + FIELD(Type) + FIELD(Lots) + FIELD(Symbol) +
                                FIELD(OpenPrice) + FIELD(StopLoss) + FIELD(TakeProfit) + FIELD(CloseTime) + FIELD(ClosePrice) +
                                FIELD(Commission) + FIELD(Swap) + FIELD(Profit) + FIELD(Comment) + FIELD(Pips) +
#ifdef REPORT_SLIPPAGE
//                                FIELD(OpenPriceRequest) + FIELD(ClosePriceRequest) +
                                FIELD(SlipPage) +
#endif // REPORT_SLIPPAGE
                                FIELD(MagicNumber) + FIELD(LengthTime);

#undef FIELD

double REPORT::Balance[];
double REPORT::BalanceNoCommission[];

double REPORT::Pips[];

double REPORT::Gain[];
double REPORT::GainNoCommission[];

double REPORT::TurnOver[];

string REPORT::Report;

#ifdef REPORT_SLIPPAGE

double REPORT::BalanceNoSlip[];
double REPORT::BalanceNoSlipCommission[];

double REPORT::PipsNoSlip[];

double REPORT::GainNoSlip[];
double REPORT::GainNoSlipCommission[];

#endif // REPORT_SLIPPAGE

#ifdef REPORT_TESTER
#ifdef __MQL5__

static int REPORT::OnTesterPasses = 0;
static string REPORT::TimeBegin = NULL;
static datetime REPORT::TimeEnd = 0;

string REPORT::TimeStr = ::MQLInfoInteger(MQL_FRAME_MODE) ? (string)::TimeLocal() : "";
const string REPORT::TimeName = ::MQLInfoInteger(MQL_FRAME_MODE) && ::StringReplace(REPORT::TimeStr, ":", ".") ? REPORT::TimeStr + " " : "";

#ifndef __TESTERBENCH__

void OnTesterPass( void )
{
  REPORT::OnTesterPass();

  return;
}

void OnTesterDeinit( void )
{
  ::ChartClose();

  return;
}

#endif // __TESTERBENCH__
#endif // __MQL5__
const ulong REPORT::TimeStart = ::GetMicrosecondCount();

sinput bool Report = true; // /.    

REPORT DeinitReport;
#endif // REPORT_TESTER

#undef HEIGHT
#undef WIDTH

#ifdef REPORT_BROWSER
  #undef BASEPATH_TESTER
  #undef BASEPATH
#endif // REPORT_BROWSER
